diff --git a/drupal7/sites/all/modules/ctools/js/modal.js b/drupal7/sites/all/modules/ctools/js/modal.js
index 98f36097..37908cf3 100644
--- a/drupal7/sites/all/modules/ctools/js/modal.js
+++ b/drupal7/sites/all/modules/ctools/js/modal.js
@@ -379,9 +379,9 @@
     css.filter = 'alpha(opacity=' + (100 * css.opacity) + ')';
     content.hide();
 
-    // if we already ahve a modalContent, remove it
-    if ( $('#modalBackdrop')) $('#modalBackdrop').remove();
-    if ( $('#modalContent')) $('#modalContent').remove();
+    // If we already have modalContent, remove it.
+    if ($('#modalBackdrop').length) $('#modalBackdrop').remove();
+    if ($('#modalContent').length) $('#modalContent').remove();
 
     // position code lifted from http://www.quirksmode.org/viewport/compatibility.html
     if (self.pageYOffset) { // all except Explorer
@@ -421,12 +421,17 @@
           return true;
         }
       }
-      if( $(target).filter('*:visible').parents('#modalContent').size()) {
-        // allow the event only if target is a visible child node of #modalContent
+
+      if ($(target).is('#modalContent, body') || $(target).filter('*:visible').parents('#modalContent').length) {
+        // Allow the event only if target is a visible child node
+        // of #modalContent.
         return true;
       }
-      if ( $('#modalContent')) $('#modalContent').get(0).focus();
-      return false;
+      else {
+        $('#modalContent').focus();
+      }
+
+      event.preventDefault();
     };
     $('body').bind( 'focus', modalEventHandler );
     $('body').bind( 'keypress', modalEventHandler );
@@ -477,6 +482,16 @@
 
     // Move and resize the modalBackdrop and modalContent on resize of the window
      modalContentResize = function(){
+
+      // position code lifted from http://www.quirksmode.org/viewport/compatibility.html
+      if (self.pageYOffset) { // all except Explorer
+      var wt = self.pageYOffset;
+      } else if (document.documentElement && document.documentElement.scrollTop) { // Explorer 6 Strict
+        var wt = document.documentElement.scrollTop;
+      } else if (document.body) { // all other Explorers
+        var wt = document.body.scrollTop;
+      }
+
       // Get our heights
       var docHeight = $(document).height();
       var docWidth = $(document).width();
@@ -486,7 +501,7 @@
 
       // Get where we should move content to
       var modalContent = $('#modalContent');
-      var mdcTop = ( winHeight / 2 ) - (  modalContent.outerHeight() / 2);
+      var mdcTop = wt + ( winHeight / 2 ) - ( modalContent.outerHeight() / 2);
       var mdcLeft = ( winWidth / 2 ) - ( modalContent.outerWidth() / 2);
 
       // Apply the changes
diff --git a/drupal7/sites/all/modules/ctools/page_manager/page_manager.admin.inc b/drupal7/sites/all/modules/ctools/page_manager/page_manager.admin.inc
index 6ef02687..73f1e604 100644
--- a/drupal7/sites/all/modules/ctools/page_manager/page_manager.admin.inc
+++ b/drupal7/sites/all/modules/ctools/page_manager/page_manager.admin.inc
@@ -95,6 +95,7 @@ function page_manager_list_page($js = NULL) {
 
   $header = array(
     array('data' => t('Type'), 'class' => array('page-manager-page-type')),
+    array('data' => t('Module'), 'class' => array('page-manager-page-module')),
     array('data' => t('Name'), 'class' => array('page-manager-page-name')),
     array('data' => t('Title'), 'class' => array('page-manager-page-title')),
     array('data' => t('Path'), 'class' => array('page-manager-page-path')),
@@ -175,9 +176,18 @@ function page_manager_get_pages($tasks, &$pages, $task_id = NULL) {
     $row = array('data' => array(), 'class' => $class, 'title' => strip_tags($task['admin description']));
 
     $type = isset($task['admin type']) ? $task['admin type'] : t('System');
+    if (isset($task['module'])) {
+      $module = $task['module'];
+    }
+    elseif (isset($task['subtask']->export_module)) {
+      $module = $task['subtask']->export_module;
+    }
+    else {
+      $module = '';
+    }
     $pages['types'][$type] = $type;
     $row['data']['type'] = array('data' => $type, 'class' => array('page-manager-page-type'));
-
+    $row['data']['module'] = array('data' => $module, 'class' => array('page-manager-page-module'));
     $row['data']['name'] = array('data' => $task_name, 'class' => array('page-manager-page-name'));
     $row['data']['title'] = array('data' => $task['admin title'], 'class' => array('page-manager-page-title'));
     $row['data']['path'] = array('data' => $visible_path, 'class' => array('page-manager-page-path'));
@@ -401,7 +411,7 @@ function page_manager_list_pages_form_submit(&$form, &$form_state) {
  * Render the edit page for a a page, custom or system.
  */
 function page_manager_edit_page($page) {
-  drupal_set_title($page->subtask['admin title']);
+  drupal_set_title($page->subtask['admin title'], PASS_THROUGH);
   // Provide and process the save page form before anything else.
   $form_state = array('page' => &$page);
   $built_form = drupal_build_form('page_manager_save_page_form', $form_state);
@@ -464,7 +474,7 @@ function page_manager_edit_page_operation() {
     return;
   }
 
-  drupal_set_title($page->subtask['admin title']);
+  drupal_set_title($page->subtask['admin title'], PASS_THROUGH);
   return $output;
 }
 
@@ -577,8 +587,8 @@ function page_manager_get_operations($page, $operations = NULL) {
     ),
   );
 
-  // Restrict variant import to users who can already execute arbitrary PHP
-  if (user_access('use PHP for settings')) {
+  // Restrict variant import due to security implications.
+  if (user_access('use ctools import')) {
     $result['actions']['children']['import'] = array(
       'title' => t('Import variant'),
       'description' => t('Add a new variant to this page from code exported from another page.'),
@@ -1308,6 +1318,7 @@ function page_manager_handler_add_submit(&$form, &$form_state) {
   else {
     $handler->conf['title'] = $plugin['title'];
   }
+  $handler->conf['name'] = $form_state['values']['name'];
   $cache->new_handler = $handler;
 
   // Figure out which forms to present them with
@@ -1398,6 +1409,21 @@ function page_manager_handler_add_form($form, $form_state, $features = array())
       '#title' => t('Title'),
       '#description' => t('Administrative title of this variant. If you leave blank it will be automatically assigned.'),
     );
+
+    $form['name'] = array(
+      '#type' => 'machine_name',
+      '#title' => t('Machine name'),
+      '#required' => FALSE,
+      '#description' => t("A unique machine-readable name for this variant. It must only contain lowercase letters, numbers, and underscores. This name will be used when exporting the variant. If left empty the variant's name will be used instead."),
+      '#size' => 32,
+      '#maxlength' => 32,
+      '#machine_name' => array(
+        'exists' => 'page_manager_handler_check_machine_name',
+        'source' => array('title'),
+      ),
+      '#field_prefix' => '<span dir="ltr">' . $task['name'] . '__',
+      '#field_suffix' => '</span>&lrm;',
+    );
   }
 
   $form['handler'] = array(
@@ -1436,6 +1462,15 @@ function page_manager_handler_add_form($form, $form_state, $features = array())
   return $form;
 }
 
+/*
+ * Check if handler's machine-name is unique
+ */
+function page_manager_handler_check_machine_name($name, $element, $form_state) {
+  $name = $form_state['task']['name'] . '__' . $name;
+
+  return count(ctools_export_load_object('page_manager_handlers', 'names', array($name)));
+}
+
 /**
  * Rearrange the order of variants.
  */
@@ -1446,15 +1481,16 @@ function page_manager_handler_import($form, &$form_state) {
     '#description' => t('Enter the name of the new variant.'),
   );
 
-  if (user_access('use PHP for settings')) {
+  if (user_access('use ctools import')) {
     $form['object'] = array(
       '#type' => 'textarea',
       '#title' => t('Paste variant code here'),
       '#rows' => 15,
     );
   }
-  // Users ordinarily can't get here without the PHP block visibility perm.
-  // In case they somehow do, though, disable the form widget for extra safety.
+  // Users ordinarily can't get here without the 'import' permission, due to
+  // security implications. In case they somehow do, though, disable the form
+  // widget for extra safety.
   else {
     $form['shoveoff'] = array(
       '#markup' => '<div>' . t('You do not have sufficient permissions to perform this action.') . '</div>',
@@ -1468,7 +1504,7 @@ function page_manager_handler_import($form, &$form_state) {
  * Make sure that an import actually provides a handler.
  */
 function page_manager_handler_import_validate($form, &$form_state) {
-  if (!user_access('use PHP for settings')) {
+  if (!user_access('use ctools import')) {
     form_error($form['shoveoff'], t('You account permissions do not permit you to import.'));
     return;
   }
diff --git a/drupal7/sites/all/modules/ctools/page_manager/page_manager.info b/drupal7/sites/all/modules/ctools/page_manager/page_manager.info
index 8103ca8c..b157f9c9 100644
--- a/drupal7/sites/all/modules/ctools/page_manager/page_manager.info
+++ b/drupal7/sites/all/modules/ctools/page_manager/page_manager.info
@@ -3,10 +3,11 @@ description = Provides a UI and API to manage pages within the site.
 core = 7.x
 dependencies[] = ctools
 package = Chaos tool suite
+version = CTOOLS_MODULE_VERSION
 
-; Information added by Drupal.org packaging script on 2014-11-19
-version = "7.x-1.5"
+; Information added by Drupal.org packaging script on 2015-01-28
+version = "7.x-1.6"
 core = "7.x"
 project = "ctools"
-datestamp = "1416423525"
+datestamp = "1422471484"
 
diff --git a/drupal7/sites/all/modules/ctools/page_manager/page_manager.module b/drupal7/sites/all/modules/ctools/page_manager/page_manager.module
index da99a578..70237520 100644
--- a/drupal7/sites/all/modules/ctools/page_manager/page_manager.module
+++ b/drupal7/sites/all/modules/ctools/page_manager/page_manager.module
@@ -213,6 +213,30 @@ function page_manager_menu_alter(&$items) {
     }
   }
 
+  // Override the core node revisions display to use the configured Page
+  // display handler.
+  if (!variable_get('page_manager_node_view_disabled', TRUE) && isset($items['node/%node/revisions/%/view'])) {
+    // Abstract the basic settings.
+    $item = array(
+      // Handle the page arguments.
+      'load arguments' => array(3),
+      'page arguments' => array(1, TRUE),
+
+      // Replace the normal node_show call with Page Manager's node view.
+      'page callback' => 'page_manager_node_view_page',
+
+      // Provide the correct path to the Page Manager file.
+      'file' => 'node_view.inc',
+      'file path' => drupal_get_path('module', 'page_manager') . '/plugins/tasks',
+    );
+    // Re-build the menu item using the normal values from node.module.
+    $items['node/%node/revisions/%/view'] = array(
+      'title' => 'Revisions',
+      'access callback' => '_node_revision_access',
+      'access arguments' => array(1),
+    ) + $item;
+  }
+
   return $items;
 }
 
@@ -416,16 +440,17 @@ function page_manager_cache_load($task_name) {
  */
 function page_manager_handler_get_name($task_name, $handlers, $handler) {
   $base = str_replace('-', '_', $task_name);
-  // Generate a unique name. Unlike most named objects, we don't let people choose
-  // names for task handlers because they mostly don't make sense.
-  $base .= '_' . $handler->handler;
-
-  // Once we have a base, check to see if it is used. If it is, start counting up.
-  $name = $base;
-  $count = 1;
-  // If taken
-  while (isset($handlers[$name])) {
-    $name = $base . '_' . ++$count;
+  // Optional machine name.
+  if (!empty($handler->conf['name'])) {
+    $name = $base . '__' . $handler->conf['name'];
+  }
+
+  // If no machine name was provided, generate a unique name.
+  else {
+    $base .= '__' . $handler->handler;
+
+    // Use the ctools uuid generator to generate a unique id.
+    $name = $base . '_' . ctools_uuid_generate();
   }
 
   return $name;
diff --git a/drupal7/sites/all/modules/ctools/page_manager/plugins/task_handlers/http_response.inc b/drupal7/sites/all/modules/ctools/page_manager/plugins/task_handlers/http_response.inc
index e5c01414..c091d9c6 100644
--- a/drupal7/sites/all/modules/ctools/page_manager/plugins/task_handlers/http_response.inc
+++ b/drupal7/sites/all/modules/ctools/page_manager/plugins/task_handlers/http_response.inc
@@ -224,6 +224,23 @@ function page_manager_http_response_edit_settings($form, &$form_state) {
     '#description' => t('Administrative title of this variant.'),
   );
 
+  $name = isset($conf['name']) ? $conf['name'] : FALSE;
+  $form['name'] = array(
+    '#type' => 'machine_name',
+    '#title' => t('Machine name'),
+    '#required' => FALSE,
+    '#default_value' => $name,
+    '#description' => t("A unique machine-readable name for this variant. It must only contain lowercase letters, numbers, and underscores. This name will be used when exporting the variant. If left empty the variant's name will be used instead."),
+    '#size' => 32,
+    '#maxlength' => 32,
+    '#machine_name' => array(
+      'exists' => 'page_manager_handler_check_machine_name',
+      'source' => array('title'),
+    ),
+    '#field_prefix' => '<span dir="ltr">' . $form_state['task_name'] . '__',
+    '#field_suffix' => '</span>&lrm;',
+  );
+
   $form['code'] = array(
     '#title' => t('Response code'),
     '#type' => 'select',
@@ -244,7 +261,19 @@ function page_manager_http_response_edit_settings($form, &$form_state) {
 }
 
 function page_manager_http_response_edit_settings_submit($form, &$form_state) {
+  $machine_name = $form_state['handler']->name;
+  $name = $form_state['task_id'] . '__' . $form_state['values']['name'];
+
+  // If new name doesn't equal machine name, we need to update and redirect.
+  if ($machine_name !== $name) {
+    $form_state['new trail'] = $form_state['trail'];
+    $delta = array_search($machine_name, $form_state['new trail']);
+    $form_state['new trail'][$delta] = $name;
+    $form_state['handler']->name = $name;
+  }
+
   $form_state['handler']->conf['title'] = $form_state['values']['title'];
+  $form_state['handler']->conf['name'] = $form_state['values']['name'];
   $form_state['handler']->conf['code'] = $form_state['values']['code'];
   $form_state['handler']->conf['destination'] = $form_state['values']['destination'];
 }
diff --git a/drupal7/sites/all/modules/ctools/page_manager/plugins/tasks/comment_reply.inc b/drupal7/sites/all/modules/ctools/page_manager/plugins/tasks/comment_reply.inc
index 0fcf9e2a..ffbafe46 100644
--- a/drupal7/sites/all/modules/ctools/page_manager/plugins/tasks/comment_reply.inc
+++ b/drupal7/sites/all/modules/ctools/page_manager/plugins/tasks/comment_reply.inc
@@ -67,7 +67,7 @@ function page_manager_comment_reply_page($node, $pid = NULL){
   }
 
   $output = ctools_context_handler_render($task, '', $contexts, array($node, $pid));
-  if ($output != FALSE) {
+  if ($output !== FALSE) {
     return $output;
   }
 
diff --git a/drupal7/sites/all/modules/ctools/page_manager/plugins/tasks/node_edit.inc b/drupal7/sites/all/modules/ctools/page_manager/plugins/tasks/node_edit.inc
index 844cd5b3..e0585e80 100644
--- a/drupal7/sites/all/modules/ctools/page_manager/plugins/tasks/node_edit.inc
+++ b/drupal7/sites/all/modules/ctools/page_manager/plugins/tasks/node_edit.inc
@@ -126,7 +126,7 @@ function page_manager_node_add($type) {
     'language' => LANGUAGE_NONE,
   );
 
-  drupal_set_title(t('Create @name', array('@name' => $types[$type]->name)));
+  drupal_set_title(t('Create @name', array('@name' => $types[$type]->name)), PASS_THROUGH);
   return page_manager_node_edit($node);
 }
 
diff --git a/drupal7/sites/all/modules/ctools/page_manager/plugins/tasks/node_view.inc b/drupal7/sites/all/modules/ctools/page_manager/plugins/tasks/node_view.inc
index b8a7e0c9..ad754e0e 100644
--- a/drupal7/sites/all/modules/ctools/page_manager/plugins/tasks/node_view.inc
+++ b/drupal7/sites/all/modules/ctools/page_manager/plugins/tasks/node_view.inc
@@ -78,6 +78,10 @@ function page_manager_node_view_menu_alter(&$items, $task) {
  * node view, which is node_page_view().
  */
 function page_manager_node_view_page($node) {
+  // Prep the node to be displayed so all of the regular hooks are triggered.
+  // Also save the output for later, in case it is needed.
+  $default_output = node_page_view($node);
+
   // Load my task plugin
   $task = page_manager_get_task('node_view');
 
@@ -85,32 +89,26 @@ function page_manager_node_view_page($node) {
   ctools_include('context');
   ctools_include('context-task-handler');
 
-  // We need to mimic Drupal's behavior of setting the node title here.
-  drupal_set_title($node->title);
-  $uri = entity_uri('node', $node);
-  // Set the node path as the canonical URL to prevent duplicate content.
-  drupal_add_html_head_link(array('rel' => 'canonical', 'href' => url($uri['path'], $uri['options'])), TRUE);
-  // Set the non-aliased path as a default shortlink.
-  drupal_add_html_head_link(array('rel' => 'shortlink', 'href' => url($uri['path'], array_merge($uri['options'], array('alias' => TRUE)))), TRUE);
+  // Load all contexts.
   $contexts = ctools_context_handler_get_task_contexts($task, '', array($node));
 
+  // Build the full output using the configured CTools plugin.
   $output = ctools_context_handler_render($task, '', $contexts, array($node->nid));
-  if ($output != FALSE) {
+  if ($output !== FALSE) {
     node_tag_new($node);
     return $output;
   }
 
-  $function = 'node_page_view';
+  // Try loading an override plugin.
   foreach (module_implements('page_manager_override') as $module) {
     $call = $module . '_page_manager_override';
     if (($rc = $call('node_view')) && function_exists($rc)) {
-      $function = $rc;
-      break;
+      return $rc($node);
     }
   }
 
-  // Otherwise, fall back.
-  return $function($node);
+  // Otherwise, fall back to the default output generated by node_page_view().
+  return $default_output;
 }
 
 /**
diff --git a/drupal7/sites/all/modules/ctools/page_manager/plugins/tasks/page.admin.inc b/drupal7/sites/all/modules/ctools/page_manager/plugins/tasks/page.admin.inc
index 88d46c5b..7c560fb8 100644
--- a/drupal7/sites/all/modules/ctools/page_manager/plugins/tasks/page.admin.inc
+++ b/drupal7/sites/all/modules/ctools/page_manager/plugins/tasks/page.admin.inc
@@ -38,7 +38,7 @@ function page_manager_page_menu(&$items, $task) {
   ) + $base;
   if ($access_callback == 'user_access') {
     $items['admin/structure/pages/import']['access callback'] = 'ctools_access_multiperm';
-    $items['admin/structure/pages/import']['access arguments'][] = 'use PHP for settings';
+    $items['admin/structure/pages/import']['access arguments'][] = 'use ctools import';
   }
 
   // AJAX callbacks for argument modal.
@@ -769,12 +769,12 @@ function page_manager_page_form_menu($form, &$form_state) {
     );
   }
   $form['menu']['parent']['weight'] = array(
-    '#title' => t('Tab weight'),
+    '#title' => t('Parent weight'),
     '#type' => 'textfield',
     '#default_value' => $menu['parent']['weight'],
     '#size' => 5,
-    '#description' => t('If the parent menu item is a tab, enter the weight of the tab. The lower the number, the more to the left it will be.'),
-    '#dependency' => array('radio:menu[type]' => array('default tab'), 'radio:menu[parent][type]' => array('tab')),
+    '#description' => t('Enter the weight of the parent item. The lower the number, the more to the left it will be.'),
+    '#dependency' => array('radio:menu[type]' => array('default tab'), 'radio:menu[parent][type]' => array('tab', 'normal')),
     '#dependency_count' => 2,
   );
 
diff --git a/drupal7/sites/all/modules/ctools/page_manager/plugins/tasks/user_edit.inc b/drupal7/sites/all/modules/ctools/page_manager/plugins/tasks/user_edit.inc
index 6d0135de..0b11bf01 100644
--- a/drupal7/sites/all/modules/ctools/page_manager/plugins/tasks/user_edit.inc
+++ b/drupal7/sites/all/modules/ctools/page_manager/plugins/tasks/user_edit.inc
@@ -97,8 +97,8 @@ function page_manager_user_edit_page($account, $category = 'account') {
   $output = ctools_context_handler_render($task, '', $contexts, array($account->uid));
   if (is_array($output)) {
     $output = drupal_render($output);
-  }  
-  if ($output != FALSE) {
+  }
+  if ($output !== FALSE) {
     return $output;
   }
 
@@ -119,7 +119,7 @@ function page_manager_user_edit_page($account, $category = 'account') {
     //call drupal_build_form.
     $form_state = array();
     $form_id = 'user_profile_form';
-    $args = array($account);
+    $args = array($account, $category);
     $form_state['build_info']['args'] = $args;
     form_load_include($form_state, 'inc', 'user', 'user.pages');
     $output = drupal_build_form($form_id, $form_state);
diff --git a/drupal7/sites/all/modules/ctools/page_manager/plugins/tasks/user_view.inc b/drupal7/sites/all/modules/ctools/page_manager/plugins/tasks/user_view.inc
index dfb40817..c428384a 100644
--- a/drupal7/sites/all/modules/ctools/page_manager/plugins/tasks/user_view.inc
+++ b/drupal7/sites/all/modules/ctools/page_manager/plugins/tasks/user_view.inc
@@ -81,7 +81,7 @@ function page_manager_user_view_page($account) {
   user_build_content($account);
 
   $output = ctools_context_handler_render($task, '', $contexts, array($account->uid));
-  if ($output != FALSE) {
+  if ($output !== FALSE) {
     return $output;
   }
 
diff --git a/drupal7/sites/all/modules/ctools/plugins/access/book.inc b/drupal7/sites/all/modules/ctools/plugins/access/book.inc
new file mode 100644
index 00000000..4b4f7eaa
--- /dev/null
+++ b/drupal7/sites/all/modules/ctools/plugins/access/book.inc
@@ -0,0 +1,94 @@
+<?php
+
+/**
+ * @file
+ * Plugin to provide access control based on whether a node belongs to a book.
+ */
+
+/**
+ * Plugins are described by creating a $plugin array which will be used
+ * by the system that includes this file.
+ */
+if (module_exists('book')) {
+  $plugin = array(
+    'title' => t("Book: node is in a book"),
+    'description' => t('Control access based upon a node belonging to a book.'),
+    'callback' => 'ctools_book_node_ctools_access_check',
+    'default' => array('book' => array()),
+    'settings form' => 'ctools_book_node_ctools_access_settings',
+    'settings form submit' => 'ctools_book_node_ctools_access_settings_submit',
+    'summary' => 'ctools_book_node_ctools_access_summary',
+    'required context' => new ctools_context_required(t('Node'), 'node'),
+  );
+}
+
+/**
+ * Settings form for the 'by book_node' access plugin.
+ */
+function ctools_book_node_ctools_access_settings($form, &$form_state, $conf) {
+  $options = array(
+    'any' => t('In any book'),
+  );
+  $books = book_get_books();
+  foreach ($books as $bid => $book) {
+    $options[$bid] = $book['title'];
+  }
+  $form['settings']['book'] = array(
+    '#title' => t('Book'),
+    '#type' => 'checkboxes',
+    '#options' => $options,
+    '#description' => t('Pass only if the node belongs to one of the selected books'),
+    '#default_value' => $conf['book'],
+    '#required' => TRUE,
+  );
+  return $form;
+}
+
+/**
+ * Check for access.
+ */
+function ctools_book_node_ctools_access_check($conf, $context) {
+  // As far as I know there should always be a context at this point, but this
+  // is safe.
+  if (empty($context) || empty($context->data) || empty($context->data->book)) {
+    return FALSE;
+  }
+
+  if ($conf['book']['any']) {
+    return !empty($context->data->book);
+  }
+
+  foreach ($conf['book'] as $bid => $value) {
+    if ($bid == 'any') {
+      continue;
+    }
+    if ($value && ($bid == $context->data->book['bid'])) {
+      return TRUE;
+    }
+  }
+
+  return FALSE;
+}
+
+/**
+ * Provide a summary description based upon the checked node_languages.
+ */
+function ctools_book_node_ctools_access_summary($conf, $context) {
+  if ($conf['book']['any']) {
+    return t('@identifier belongs to a book', array('@identifier' => $context->identifier));
+  }
+
+  $books = array();
+  foreach ($conf['book'] as $bid => $value) {
+    if ($value) {
+      $node = node_load($bid);
+      $books[] = $node->title;
+    }
+  }
+
+  if (count($books) == 1) {
+    return t('@identifier belongs to the book "@book"', array('@book' => $books[0], '@identifier' => $context->identifier));
+  }
+
+  return t('@identifier belongs in multiple books', array('@identifier' => $context->identifier));
+}
